#!/usr/bin/perl
###########
$Version="1.1";
###############################################################################
# Demant It, mp3 streaming server									#
# Copyright April 2003 Red Dragon Enterprises and distributed under the GNU Public License		#
# Agreement found distributed with this program							#
# Red Dragon Enterprises, http://www.red-dragon2.com						#
###############################################################################
$script="http://$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}";
require "cookie.pl";
require "program.cfg";
undef($C_Exp_Date);
use Mysql;
use MP3::Info;
&Get_Info;
&Get_Cookie('playlist','remember');
if($FORM{'do'} eq ""){&Start;}
if($FORM{'do'} eq "view artist"){&View_Artist;}
if($FORM{'do'} eq "view song"){&View_Song;}
if($FORM{'do'} eq "add playlist"){&Add_Playlist;}
if($FORM{'do'} eq "view playlist"){&View_Playlist;}
if($FORM{'do'} eq "remove playlist"){&Remove_Playlist;}
if($FORM{'do'} eq "clear list"){&Clear_List;}
if($FORM{'do'} eq "play playlist"){&Play_Playlist;}
if($FORM{'do'} eq "play song"){&Play_Song;}
if($FORM{'do'} eq "Search"){&Search;}
if($FORM{'do'} eq "play single"){&Play_Single;}
if($FORM{'do'} eq "viewby"){&View_By;}
if($FORM{'do'} eq "view album"){&View_Album;}
if($FORM{'do'} eq "add album"){&Add_Album;}
if($FORM{'do'} eq "remember"){&Remember;}

##

sub Start
{
&Top;
&Nav;
&Bottom;
}

## continue here

sub Remember
{
local(@months)=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
local(@days)=('Sun','Mon','Tue','Wen','Thu','Fri','Sat');
local($time)=time+604800;
local($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($time);
$year+=1900;
&Get_Cookie('playlist');
if($Cookies{'remember'} eq "yes"){undef($C_Exp_Date);$Cookies{'remember'}="no";}
else{$C_Exp_Date=qq(@days[$mday], 31-$months[$mon]-$year 00:00:00 GMT);$Cookies{'remember'}='yes';}
&Set_Cookies('playlist',$Cookies{'playlist'},'remember',$Cookies{'remember'});
&Top;
print qq(<META CONTENT="3;URL=$ENV{'HTTP_REFERER'}" HTTP-EQUIV="Refresh">
<CENTER>Your playlist has been updated, you should be returned to your previous screen.<BR>
If not, click <A HREF="$ENV{'HTTP_REFERER'}">Here</A></CENTER>\n);
&Bottom;
}

##

sub Add_Album
{
local($album)=$FORM{'album'};$album=~s/\'/\\\'/g;
local($statement,$query_output,$db);
$db=Mysql->connect($dbhost,$dbname,$dbuser,$dbpass);
$statement=qq(SELECT id FROM songs WHERE album='$album' ORDER BY track ASC);
$query_output=$db->query($statement);
local($id);
while(($id)=$query_output->fetchrow)
	{
	$Cookies{'playlist'}.="$id|";
	}
if($Cookies{'remember'} eq "yes")
	{
	local(@months)=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	local(@days)=('Sun','Mon','Tue','Wen','Thu','Fri','Sat');
	local($time)=time+604800;
	local($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($time);
	$year+=1900;
	$C_Exp_Date=qq(@days[$mday], 31-$months[$mon]-$year 00:00:00 GMT);
	}
&Set_Cookies('playlist',$Cookies{'playlist'},'remember',$Cookies{'remember'});
&Top;
print qq(<META CONTENT="3;URL=$ENV{'HTTP_REFERER'}" HTTP-EQUIV="Refresh">
<CENTER>Your playlist has been updated, you should be returned to your previous screen.<BR>
If not, click <A HREF="$ENV{'HTTP_REFERER'}">Here</A></CENTER>\n);
&Bottom;
}

##

sub View_Album
{
local($sartist);
local($album)=$FORM{'album'};$album=~s/\'/\\\'/g;
local($statement,$query_output,$db);
$db=Mysql->connect($dbhost,$dbname,$dbuser,$dbpass);
if($FORM{'artist'})
	{
	$statement=qq(SELECT artist FROM artists WHERE id='$FORM{'artist'}');
	$query_output=$db->query($statement);
	$sartist=$query_output->fetchrow;
	}
$statement=qq(SELECT songs.id,songs.title,artists.artist,songs.track,SEC_TO_TIME(songs.ptime) FROM songs,artists WHERE songs.album='$album' && songs.artist=artists.id ORDER BY track ASC);
$query_output=$db->query($statement);
local($id,$title,$artist,$track,$time);
&Top;
&Nav;
print qq(<TABLE ALIGN=center BORDER=1 CELLPADDING=2 CELLSPACING=2 CLASS="prgout" WIDTH=100%>
<TR><TD ALIGN=center COLSPAN=3><B>$FORM{'album'}</B></TD></TR>\n);
local($column)=1;
while(($id,$title,$artist,$track,$time)=$query_output->fetchrow)
	{
	if($column==1)	
		{
		print qq(<TR><TD CLASS="prgout" ALIGN=left WIDTH=33% VALIGN=top>);
		if($artist eq $sartist){print qq(<B>);}
		print qq(<I>$title</I>);
		if($artist eq $sartist){print qq(</B>);}
		print qq(<TABLE ALIGN=center BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100% CLASS="detail">
<TR><TD CLASS="detail" ALIGN=left>Track: $track</TD>
<TD CLASS="detail" ALIGN=right>Time: $time</TD></TR>
</TABLE><BR>$artist<BR>
<TABLE ALIGN=center BORDER=1 CELLPADDING=2 CELLSPACING=2 CLASS="prgout" WIDTH=100%>
<TR><TD CLASS="prgout" ALIGN=center><A HREF="$script?do=view+song&id=$id">Info</A></TD>
<TD CLASS="prgout" ALIGN=center><A HREF="$script?do=add+playlist&id=$id">+ Playlist</A></TD>
<TD CLASS="prgout" ALIGN=center><A HREF="$script?do=play+single&id=$id">Play</A></TD></TR></TABLE></TD>\n);
		$column=2;
		}
	elsif($column==2)
		{
		print qq(<TD CLASS="prgout" ALIGN=left WIDTH=33% VALIGN=top>);
		if($artist eq $sartist){print qq(<B>);}
		print qq(<I>$title</I>);
		if($artist eq $sartist){print qq(</B>);}
		print qq(<TABLE ALIGN=center BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100% CLASS="detail">
<TR><TD CLASS="detail" ALIGN=left>Track: $track</TD>
<TD CLASS="detail" ALIGN=right>Time: $time</TD></TR>
</TABLE><BR>$artist<BR>
<TABLE ALIGN=center BORDER=1 CELLPADDING=2 CELLSPACING=2 CLASS="prgout" WIDTH=100%>
<TR><TD CLASS="prgout" ALIGN=center><A HREF="$script?do=view+song&id=$id">Info</A></TD>
<TD CLASS="prgout" ALIGN=center><A HREF="$script?do=add+playlist&id=$id">+ Playlist</A></TD>
<TD CLASS="prgout" ALIGN=center><A HREF="$script?do=play+single&id=$id">Play</A></TD></TR></TABLE></TD>\n);
		$column=3;
		}
	else
		{
		print qq(<TD CLASS="prgout" ALIGN=left WIDTH=33% VALIGN=top>);
		if($artist eq $sartist){print qq(<B>);}
		print qq(<I>$title</I>);
		if($artist eq $sartist){print qq(</B>);}
		print qq(<TABLE ALIGN=center BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100% CLASS="detail">
<TR><TD CLASS="detail" ALIGN=left>Track: $track</TD>
<TD CLASS="detail" ALIGN=right>Time: $time</TD></TR>
</TABLE><BR>$artist<BR>
<TABLE ALIGN=center BORDER=1 CELLPADDING=2 CELLSPACING=2 CLASS="prgout" WIDTH=100%>
<TR><TD CLASS="prgout" ALIGN=center><A HREF="$script?do=view+song&id=$id">Info</A></TD>
<TD CLASS="prgout" ALIGN=center><A HREF="$script?do=add+playlist&id=$id">+ Playlist</A></TD>
<TD CLASS="prgout" ALIGN=center><A HREF="$script?do=play+single&id=$id">Play</A></TD></TR></TABLE></TD></TR>\n);
		$column=1;
		}
	}
local($lalbum)=$FORM{'album'};$lalbum=~s/ /+/g;
print qq(<TR><TD CLASS="prgout" ALIGN=center COLSPAN=3><A HREF="$script?do=add+album&album=$lalbum">Add Album to Playlist</A></TD></TR>
</TABLE>\n);
&Bottom;
}

##

sub View_By
{
local($statement,$query_output,$db);
$db=Mysql->connect($dbhost,$dbname,$dbuser,$dbpass);
if($FORM{'by'} eq "artist"){$statement=qq(SELECT id,artist FROM artists  WHERE artist LIKE '$FORM{'start'}%' ORDER BY artist ASC);}
elsif($FORM{'by'} eq "album"){$statement=qq(SELECT DISTINCT(album) FROM songs WHERE album LIKE '$FORM{'start'}%' ORDER BY album ASC);}
$query_output=$db->query($statement);
&Top;
&Nav;
print qq(<TABLE ALIGN=center BORDER=1 CELLPADDING=2 CELLSPACING=2 CLASS="prgout" WIDTH=100%>\n);
local($column)=1;
if($FORM{'by'} eq "artist")
	{
	print qq(<TR><TD CLASS="prgout" ALIGN=center COLSPAN=3><B>Artists of "\u$FORM{'start'}"</B></TD></TR>\n);
	local($id,$artist);
	while(($id,$artist)=$query_output->fetchrow)
		{
		if($column == 1)
			{
			print qq(<TR><TD CLASS="prgout" ALIGN=left WIDTH=33%><A HREF="$script?do=view+artist&id=$id">$artist</A></TD>\n);
			$column=2;
			}
		elsif($column == 2)
			{
			print qq(<TD CLASS="prgout" ALIGN=left WIDTH=33%><A HREF="$script?do=view+artist&id=$id">$artist</A></TD>\n);
			$column=3;
			}
		else
			{
			print qq(<TD CLASS="prgout" ALIGN=left WIDTH=33%><A HREF="$script?do=view+artist&id=$id">$artist</A></TD></TR>\n);
			$column=1;
			}
		}
	}
if($FORM{'by'} eq "album")
	{
	local($album);
	print qq(<TR><TD CLASS="prgout" ALIGN=center COLSPAN=3><B>Albums of "\u$FORM{'start'}"</B></TD></TR>\n);
	while(($album)=$query_output->fetchrow)
		{
		local($lalbum)=$album;$lalbum=~s/ /+/g;
		if($column == 1)
			{
			print qq(<TR><TD CLASS="prgout" ALIGN=left WIDTH=33%><A HREF="$script?do=view+album&album=$lalbum">$album</A></TD>\n);
			$column=2;
			}
		elsif($column == 2)
			{
			print qq(<TD CLASS="prgout" ALIGN=left WIDTH=33%><A HREF="$script?do=view+album&album=$lalbum">$album</A></TD>\n);
			$column=3;
			}
		else
			{
			print qq(<TD CLASS="prgout" ALIGN=left WIDTH=33%><A HREF="$script?do=view+album&album=$lalbum">$album</A></TD></TR>\n);
			$column=1;
			}
		}
	}
if($column==2){print qq(<TD CLASS="prgout" COLSPAN=2>&nbsp;</TD></TR>\n);}
if($column==3){print qq(<TD CLASS="prgout">&nbsp;</TD></TR>\n);}
print qq(</TABLE>\n);
&Bottom;
}

##

sub Search
{
@sterm=split(/&/,$FORM{'sterm'});
local($statement,$query_output,$db);
$db=Mysql->connect($dbhost,$dbname,$dbuser,$dbpass);
$statement=qq(SELECT songs.id,songs.title,artists.artist,songs.album,songs.directory,songs.file FROM songs,artists WHERE artists.id=songs.artist && \();
for($i=0;$i<=$#sterm;$i++)
	{
	$sterm[$i]=~s/\'/\\\'/g;
	if($FORM{'how'} eq "artist"){$statement.=qq( artists.artist LIKE '%$sterm[$i]%');}
	if($FORM{'how'} eq "song"){$statement.=qq( songs.title LIKE '%$sterm[$i]%');}
	if($FORM{'how'} eq "album"){$statement.=qq( songs.album LIKE '%$sterm[$i]%');}
	if($FORM{'how'} eq "genre"){$statement.=qq( songs.genre LIKE '%$sterm[$i]%');}
	if($sterm[$i+1]){$statement.=qq( || );}
	}
$statement.=qq(\));
$query_output=$db->query($statement);
local($id,$title,$artist,$album,$directory,$file);
&Top;
&Nav;
print qq(<TABLE ALIGN=center BORDER=1 CELLPADDING=2 CELLSPACING=2 WIDTH=100% CLASS="prgout">
<TR><TD CLASS="prgout" ALIGN=center COLSPAN=2><B>Search Results for "$FORM{'sterm'}" by \u$FORM{'how'}</B></TD></TR>\n);
local($column)=1;
while(($id,$title,$artist,$album)=$query_output->fetchrow)
	{
	local($mp3)=$file;$mp3=~s/\.mp3/\.pls/;
	if($column==1)
		{
		print qq(<TR><TD CLASS="prgout" ALIGN=left><I>$title</I> <A HREF="$script?do=view+song&id=$id">Info</A>
<A HREF="$script?do=add+playlist&id=$id">+ Playlist</A>
<A HREF="$script?do=play+single&id=$id">Play</A>
<BR>$album</TD>\n);
		$column=2;
		}
	else
		{
		print qq(<TD CLASS="prgout" ALIGN=left><I>$title</I> <A HREF="$script?do=view+song&id=$id">Info</A>
<A HREF="$script?do=add+playlist&id=$id">+ Playlist</A>
<A HREF="$script?do=play+single&id=$id">Play</A>
<BR>$album</TD></TR>\n);
		$column=1;
		}
	}
print qq(</TABLE>);
&Bottom;
}

##

sub Play_Song
{
local(@deny,@allow,$allow);
if($security eq "allow,deny")
	{
	open(FILE,"deny.dat");
	@deny=<FILE>;
	close(FILE);
	foreach(@deny)
		{
		chomp($_);
		if($_ eq $ENV{'REMOTE_ADDR'})
			{
			print "content-type:  audio/x-mpegurl\n\n";
			print qq(The IP address, $ENV{'REMOTE_ADDR'}, isn't permitted to access this MP3 server.\n);
			exit;
			}
		}
	}
if($security eq "deny,allow")
	{
	open(FILE,"allow.dat");
	@allow=<FILE>;
	close(FILE);
	$allow=0;
	foreach(@allow)
		{
		chomp($_);
		if($_ eq $ENV{'REMOTE_ADDR'})
			{
			$allow=1;
			last;
			}
		}
	}

if(!$allow)
	{
	print "content-type:  audio/x-mpegurl\n\n";
	print qq(The IP address, $ENV{'REMOTE_ADDR'}, isn't permitted to access this MP3 server.\n);
	exit;
	}
open(FILE,"agents.dat");
local(@agents)=<FILE>;
close(FILE);
undef($allow);
if($useagents eq "yes")
	{
	foreach(@agents)
		{
		chomp($_);
		if($ENV{'HTTP_USER_AGENT'} =~ /$_/i)
			{
			$allow=1;
			last;
			}
		}
	if(!$allow)
		{
		print "content-type:  audio/x-mpegurl\n\n";
		print qq(The User Agent address, $ENV{'HTTP_USER_AGENT'}, isn't permitted to access this MP3 server.\n);
		exit;
		}
	}
local($statement,$query_output,$db);
$db=Mysql->connect($dbhost,$dbname,$dbuser,$dbpass);
$statement=qq(SELECT songs.title,songs.file,directories.directory,artists.artist FROM songs,directories,artists WHERE songs.id='$FORM{'id'}' && songs.directory=directories.id && songs.artist=artists.id);
$query_output=$db->query($statement);
local($title,$file,$directory,$artist)=$query_output->fetchrow;
$offset=$ENV{'HTTP_RANGE'};
$offset=~s/^bytes=(\d*)-.*$/$1/;
local($tag)=get_mp3info("$content/$directory/$file");
$ENV{'SCRIPT_NAME'}="$title.mp3";
print qq(icy-name: $title - $artist
icy-size: ).$tag->{SIZE}.qq(
Content-Disposition: inline; filename=$title.mp3
Content-Length: ).$tag->{SIZE}.qq(
Content-Type: audio/x-mpeg\n\n);
open(FILE,"$content/$directory/$file");
seek(FILE,$offset,0);
while(read(FILE,$data,8192)){print $data;}
close(FILE);
exit;
}

##

sub Play_Single
{
local(@deny,@allow,$allow);
if($security eq "allow,deny")
	{
	open(FILE,"deny.dat");
	@deny=<FILE>;
	close(FILE);
	foreach(@deny)
		{
		chomp($_);
		if($_ eq $ENV{'REMOTE_ADDR'})
			{
			print "content-type:  audio/x-mpegurl\n\n";
			print qq(The IP address, $ENV{'REMOTE_ADDR'}, isn't permitted to access this MP3 server.\n);
			exit;
			}
		}
	}
if($security eq "deny,allow")
	{
	open(FILE,"allow.dat");
	@allow=<FILE>;
	close(FILE);
	$allow=0;
	foreach(@allow)
		{
		chomp($_);
		if($_ eq $ENV{'REMOTE_ADDR'})
			{
			$allow=1;
			last;
			}
		}
	}
if(!$allow)
	{
	print "content-type:  audio/x-mpegurl\n\n";
	print qq(The IP address, $ENV{'REMOTE_ADDR'}, isn't permitted to access this MP3 server.\n);
	exit;
	}
if(($ENV{'HTTP_USER_AGENT'} =~ /Gecko/i)&&($ENV{'HTTP_USER_AGENT'} =~ /Netscape/i))
	{
	local($playlist)=qq(#EXTM3U\n);
	local($statement,$query_output,$db);
	$db=Mysql->connect($dbhost,$dbname,$dbuser,$dbpass);
	$statement=qq(SELECT songs.title,directories.directory,songs.file,artists.artist FROM directories,songs,artists WHERE songs.id='$FORM{'id'}' && songs.directory=directories.id && songs.artist=artists.id);
	$query_output=$db->query($statement);
	local($title,$directory,$file,$artist)=$query_output->fetchrow;
	local($tag)=get_mp3info("$content/$directory/$file");
	$playlist.=qq(#EXTINF:).int($tag->{SECS}).qq(,$artist - $title
$script?do=play+song&id=$FORM{'id'}\n);
	$ENV{'SCRIPT_NAME'}="listen.pls";
	print qq(Pragma: no-cache\nContent-Disposition: inline; filename=listen.pls\nContent-type: audio/x-mpegurl\n\n);
	print qq($playlist);
	exit;
	}
else
	{
	local($playlist)=qq([playlist]
File1=$script?do=play+song&id=$FORM{'id'}
Title1=$title - $artist
Length1=).int($tag->{SECS}).qq(
Numberofentries=1
Version=2);
	print qq(Pragma: no-cache\nContent-Disposition: inline; filename=listen.pls\nContent-type: audio/x-scpls\n\n);
	print qq($playlist);
	exit;
	}
}

##

sub Play_Playlist
{
local(@deny,@allow,$allow);
if($security eq "allow,deny")
	{
	open(FILE,"deny.dat");
	@deny=<FILE>;
	close(FILE);
	foreach(@deny)
		{
		chomp($_);
		if($_ eq $ENV{'REMOTE_ADDR'})
			{
			print "content-type:  audio/x-mpegurl\n\n";
			print qq(The IP address, $ENV{'REMOTE_ADDR'}, isn't permitted to access this MP3 server.\n);
			exit;
			}
		}
	}
if($security eq "deny,allow")
	{
	open(FILE,"allow.dat");
	@allow=<FILE>;
	close(FILE);
	$allow=0;
	foreach(@allow)
		{
		chomp($_);
		if($_ eq $ENV{'REMOTE_ADDR'})
			{
			$allow=1;
			last;
			}
		}
	}
if(!$allow)
	{
	print "content-type:  audio/x-mpegurl\n\n";
	print qq(The IP address, $ENV{'REMOTE_ADDR'}, isn't permitted to access this MP3 server.\n);
	exit;
	}
local(@list)=split(/\|/,$Cookies{'playlist'});
local($statement,$query_output,$db);
$db=Mysql->connect($dbhost,$dbname,$dbuser,$dbpass);
if(($ENV{'HTTP_USER_AGENT'} =~ /Gecko/i)&&($ENV{'HTTP_USER_AGENT'} =~ /Netscape/i))
	{
	local($playlist)=qq(#EXTM3U\n);
	foreach(@list)

		{
		if($_)
			{
			$statement=qq(SELECT songs.title,directories.directory,songs.file,artists.artist FROM directories,songs,artists WHERE songs.id='$_' && songs.directory=directories.id && songs.artist=artists.id);
			$query_output=$db->query($statement);
			local($title,$directory,$file,$artist)=$query_output->fetchrow;
			local($tag)=get_mp3info("$content/$directory/$file");
			$file=~s/\s/%20/g;
			$playlist.=qq(#EXTINF:).int($tag->{SECS}).qq(,$artist - $title
$script?do=play+song&id=$_\n);
			}
		}
	$ENV{'SCRIPT_NAME'}="listen.pls";
	print qq(Pragma: no-cache\nContent-Disposition: inline; filename=listen.pls\nContent-type: audio/x-mpegurl\n\n);
	print qq($playlist);
	exit;
	}
elsif($ENV{'HTTP_USER_AGENT'} =~ /Opera/i)
	{
	local($playlist)=qq(#EXTM3U\n);
	foreach(@list)
		{
		if($_)
			{
			$statement=qq(SELECT songs.title,directories.directory,songs.file,artists.artist FROM directories,songs,artists WHERE songs.id='$_' && songs.directory=directories.id && songs.artist=artists.id);
			$query_output=$db->query($statement);
			local($title,$directory,$file,$artist)=$query_output->fetchrow;
			local($tag)=get_mp3info("$content/$directory/$file");
			$file=~s/\s/%20/g;
			$playlist.=qq(#EXTINF:).int($tag->{SECS}).qq(,$artist - $title
$script?do=play+song&id=$_\n);
			}
		}
	$ENV{'SCRIPT_NAME'}="listen.pls";
	print qq(Pragma: no-cache\nContent-Disposition: inline; filename=listen.pls\nContent-type: audio/x-scpls\n\n);
	print qq($playlist);
	exit;
	}
else
	{
	local($i)=0;
	local($playlist)=qq([playlist]\n);
	foreach(@list)
		{
		if($_)
			{
			$i++;
			$statement=qq(SELECT songs.title,directories.directory,songs.file,artists.artist FROM directories,songs,artists WHERE songs.id='$_' && songs.directory=directories.id && songs.artist=artists.id);
			$query_output=$db->query($statement);
			local($title,$directory,$file,$artist)=$query_output->fetchrow;
			local($tag)=get_mp3info("$content/$directory/$file");
			$file=~s/\.mp3$/\.pls/;
			$file=~s/\s/%20/g;
			$playlist.=qq(FILE$i=$script?do=play+song&id=$_
Title$i=$artist - $title
Length$i=).int($tag->{SECS}).qq(\n);
			}
		}
	$playlist.=qq(Numberofentries=$i
Version=2\n);
	$ENV{'SCRIPT_NAME'}="listen.pls";
	print qq(Pragma: no-cache\nContent-Disposition: inline; filename=listen.pls\nContent-type: audio/x-scpls\n\n);
	print qq($playlist);
	exit;
	}	
}

##

sub Clear_List
{
undef($Cookies{'playlist'});

if($Cookies{'remember'} eq "yes")
	{
	local(@months)=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	local(@days)=('Sun','Mon','Tue','Wen','Thu','Fri','Sat');
	local($time)=time+604800;
	local($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($time);
	$year+=1900;
	$C_Exp_Date=qq(@days[$mday], 31-$months[$mon]-$year 00:00:00 GMT);
	}
&Set_Cookies('playlist','','remember',$Cookies{'remember'});
&Top;
print qq(<META CONTENT="3;URL=$ENV{'HTTP_REFERER'}" HTTP-EQUIV="Refresh">
<CENTER>Your playlist has been updated, you should be returned to your previous screen.<BR>
If not, click <A HREF="$ENV{'HTTP_REFERER'}">Here</A></CENTER>\n);
&Bottom;
}

##

sub Remove_Playlist
{
local(@list)=split(/\|/,$Cookies{'playlist'});
local(@newlist);
foreach(@list)
	{
	if(($_ ne $FORM{'id'})&&($_))
		{
		push(@newlist,$_);
		}
	}
local($newlist)=join("|",@newlist)."|";
if($Cookies{'remember'} eq "yes")
	{
	local(@months)=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	local(@days)=('Sun','Mon','Tue','Wen','Thu','Fri','Sat');
	local($time)=time+604800;
	local($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($time);
	$year+=1900;
	$C_Exp_Date=qq(@days[$mday], 31-$months[$mon]-$year 00:00:00 GMT);
	}
&Set_Cookies('playlist',$newlist,'remember',$Cookies{'remember'});
&Top;
print qq(<META CONTENT="3;URL=$ENV{'HTTP_REFERER'}" HTTP-EQUIV="Refresh">
<CENTER>Your playlist has been updated, you should be returned to your previous screen.<BR>
If not, click <A HREF="$ENV{'HTTP_REFERER'}">Here</A></CENTER>\n);
&Bottom;
}

##

sub View_Playlist
{
local(@list)=split(/\|/,$Cookies{'playlist'});
local($statement,$query_output,$db);
$db=Mysql->connect($dbhost,$dbname,$dbuser,$dbpass);
&Top;
&Nav;
print qq(<FORM ACTION="$script" METHOD="Post" NAME="PlayList">
<TABLE ALIGN=center BORDER=1 CELLPADDING=2 CELLSPACING=2 WIDTH=100% CLASS="prgout">
<TR><TD ALIGN=center COLSPAN=3><B>PlayList</B></TD></TR>\n);
for($i=0;$i<=$#list;$i++)
	{
	if($list[$i])
		{
		$statement=qq(SELECT songs.title,artists.artist,songs.album,songs.file,directories.directory FROM songs,artists,directories WHERE songs.id='$list[$i]' && directories.id=songs.directory && songs.artist=artists.id);
		$query_output=$db->query($statement);
		local($title,$artist,$album,$file,$directory)=$query_output->fetchrow;
		$file=~s/\.mp3$/\.pls/;
		print qq(<TR><TD CLASS="prgout" ALIGN=left>$title - $artist - $album</TD>
<TD CLASS="prgout" ALIGN=center><A HREF="$script?do=play+single&id=$list[$i]">Play</A></TD>
<TD CLASS="prgout" ALIGN=center><A HREF="$script?do=remove+playlist&id=$list[$i]">Remove</A></TD></TR>\n);
		}
	}
print qq(</TABLE>
</FORM>\n);
&Bottom;
}

##

sub Add_Playlist
{
$Cookies{'playlist'}.="$FORM{'id'}|";
if($Cookies{'remember'} eq "yes")
	{
	local(@months)=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	local(@days)=('Sun','Mon','Tue','Wen','Thu','Fri','Sat');
	local($time)=time+604800;
	local($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($time);
	$year+=1900;
	$C_Exp_Date=qq(@days[$mday], 31-$months[$mon]-$year 00:00:00 GMT);
	}
&Set_Cookies('playlist',$Cookies{'playlist'},'remember',$Cookies{'remember'});
&Top;
print qq(<META CONTENT="3;URL=$ENV{'HTTP_REFERER'}" HTTP-EQUIV="Refresh">
<CENTER>Your playlist has been updated, you should be returned to your previous screen.<BR>
If not, click <A HREF="$ENV{'HTTP_REFERER'}">Here</A></CENTER>\n);
&Bottom;
}

##

sub View_Song
{
local(@stereo)=('Mono','Stereo');
local($statement,$query_output,$db);
$db=Mysql->connect($dbhost,$dbname,$dbuser,$dbpass);
$statement=qq(SELECT songs.file,artists.artist,directories.directory,songs.title,songs.album,songs.track,songs.syear,songs.genre,SEC_TO_TIME(songs.ptime) FROM songs,artists,directories WHERE songs.id='$FORM{'id'}' && songs.artist=artists.id && songs.directory=directories.id);
$query_output=$db->query($statement);
local($file,$artist,$directory,$title,$album,$track,$year,$genre,$time)=$query_output->fetchrow;
$mp3=$file;$mp3=~s/\.mp3/\.pls/;
local($tag)=get_mp3info("$content/$directory/$file");
&Top;
&Nav;
print qq(<TABLE ALIGN=center BORDER=1 CELLPADDING=2 CELLSPACING=2 WIDTH=50% CLASS="prgout">
<TR><TD CLASS="prgout" ALIGN=center COLSPAN=2><B>$title</B></TD></TR>
<TR><TD CLASS="prgout" ALIGN=center><A HREF="$script?do=add+playlist&id=$FORM{'id'}">Add to Playlist</A></TD>
<TD CLASS="prgout" ALIGN=center><A HREF="$script?do=play+single&id=$FORM{'id'}">Play</A></TD></TR>
<TR><TD CLASS="prgout" ALIGN=left>Artist</TD>
<TD CLASS="prgout" ALIGN=left>$artist</TD></TR>
<TR><TD CLASS="prgout" ALIGN=left>Album</TD>
<TD CLASS="prgout" ALIGN=left>$album</TD></TR>
<TR><TD CLASS="prgout" ALIGN=left>Track</TD>
<TD CLASS="prgout" ALIGN=left>$track</TD></TR>
<TR><TD CLASS="prgout" ALIGN=left>Year</TD>
<TD CLASS="prgout" ALIGN=left>$year</TD></TR>
<TR><TD CLASS="prgout" ALIGN=left>Genre</TD>
<TD CLASS="prgout" ALIGN=left>$genre</TD></TR>
<TR><TD CLASS="prgout" ALIGN=left>Type</TD>
<TD CLASS="prgout" ALIGN=left>).$stereo[$tag->{STEREO}].qq(</TD></TR>
<TR><TD CLASS="prgout" ALIGN=left>Frequency</TD>
<TD CLASS="prgout" ALIGN=left>).$tag->{FREQUENCY}.qq(</TD></TR>
<TR><TD CLASS="prgout" ALIGN=left>Time</TD>
<TD CLASS="prgout" ALIGN=left>$time</TD></TR>
</TABLE>\n);
&Bottom;
}

##

sub Nav
{
local($statement,$query_output,$db);
$db=Mysql->connect($dbhost,$dbname,$dbuser,$dbpass);
$statement=qq(SELECT COUNT(id) FROM songs);
$query_output=$db->query($statement);
local($songs)=$query_output->fetchrow;
$statement=qq(SELECT COUNT(id) FROM artists);
$query_output=$db->query($statement);
local($artists)=$query_output->fetchrow;
$statement=qq(SELECT SEC_TO_TIME(SUM(ptime)) AS TIME FROM songs);
$query_output=$db->query($statement);
local($time)=$query_output->fetchrow;
local(@info)=split(/\t/,qx|du -hs $content|);
local($size)=$info[0];
$statement=qq(SELECT COUNT(DISTINCT(album)) FROM songs);
$query_output=$db->query($statement);
local($albums)=$query_output->fetchrow;
$statement=qq(SELECT COUNT(DISTINCT(genre)) FROM songs);
$query_output=$db->query($statement);
local($genres)=$query_output->fetchrow;
print qq(<TABLE ALIGN=center BORDER=0 CELLPADDING=2 CELLSPACING=2>
<TR><TD VALIGN=top>
<TABLE ALIGN=center BORDER=1 CELLPADDING=2 CELLSPACING=2 CLASS="summary">
<TR><TD CLASS="summary" ALIGN=left>$songs Songs</TD>
<TD CLASS="summary" ALIGN=left>$artists Artists</TD>
<TD CLASS="summary" ALIGN=left>$time Total Time</TD></TR>
<TR><TD CLASS="summary" ALIGN=left>$albums Albums</TD>
<TD CLASS="summary" ALIGN=left>$genres Genres</TD>
<TD CLASS="summary" ALIGN=left>$size Total Size</TD></TR>
</TABLE>
<FORM ACTION="$script" METHOD="GET">
<TABLE ALIGN=center BORDER=0 CELLPADDING=2 CELLSPACING=2 CLASS="nav">
<TR><TD CLASS="nav" ALIGN=center COLSPAN=2><SELECT NAME="how" SIZE=1>
<OPTION VALUE="artist">Artist Name
<OPTION VALUE="song">Song Name
<OPTION VALUE="album">Album Name
<OPTION VALUE="genre">Genre Name
</SELECT></TD></TR>
<TR><TD CLASS="nav" ALIGN=right><INPUT NAME="sterm" VALUE="$FORM{'sterm'}" TYPE="text" SIZE=20,1></TD>
<TD CLASS="nav" ALIGN=left><INPUT TYPE="submit" VALUE="Search"></TD></TR>
</TABLE>
<INPUT NAME="do" TYPE="hidden" VALUE="Search">
</FORM></TD>
<TD VALIGN=top>
<TABLE ALIGN=center BORDER=1 CELLPADDING=2 CELLSPACING=2 CLASS="summary">
<TR><TD CLASS="summary" ALIGN=left>Artists ($artists) <INPUT TYPE="button" VALUE="List All" onClick="javascript:location.href='$script?do=viewby&by=artist&start='"></TD></TR>
<TR><TD CLASS="summary" ALIGN=left>);
for(a..z)
	{
	print qq(<A HREF="$script?do=viewby&by=artist&start=$_">\u$_</A>\n);
	if(($_ eq "m")||($_ eq "y")){print qq(<BR>);}
	}
for(0..9)
	{
	print qq(<A HREF="$script?do=viewby&by=artist&start=$_">\u$_</A>\n);
	}
print qq(</TD></TR>
</TABLE>
</TD><TD VALIGN=top>
<TABLE ALIGN=center BORDER=1 CELLPADDING=2 CELLSPACING=2 CLASS="summary">
<TR><TD CLASS="summary" ALIGN=left>Albums ($albums) <INPUT TYPE="button" VALUE="List All" onClick="javascript:location.href='$script?do=viewby&by=album&start='"></TD></TR>
<TR><TD CLASS="summary" ALIGN=left>);
for(a..z)
	{
	print qq(<A HREF="$script?do=viewby&by=album&start=$_">\u$_</A>\n);
	if(($_ eq "m")||($_ eq "y")){print qq(<BR>);}
	}
for(0..9)
	{
	print qq(<A HREF="$script?do=viewby&by=album&start=$_">\u$_</A>\n);
	}
print qq(</TD></TR>
</TABLE>
</TD></TR>
</TABLE>
<TABLE ALIGN=center BORDER=1 CELLPADDING=2 CELLSPACING=2 CLASS="nav">
<TR><TD CLASS="nav" ALIGN=center><A HREF="$script">Home</A></TD>
<TD CLASS="nav" ALIGN=center><A HREF="$script?do=view+playlist">View Playlist</A></TD>
<TD CLASS="nav" ALIGN=center><A HREF="$script?do=play+playlist">Play Playlist</A></TD>
<TD CLASS="nav" ALIGN=center><A HREF="$script?do=clear+list">Clear Playlist</A></TD>
<TD CLASS="nav" ALIGN=center><A HREF="$script?do=remember">);
if($Cookies{'remember'} eq "yes"){print qq(Don't );}
print qq(Remember Playlist Settings</A></TD></TR>
</TABLE>\n);
}

##

sub View_Artist
{
local($statement,$query_output,$db);
$db=Mysql->connect($dbhost,$dbname,$dbuser,$dbpass);
$statement=qq(SELECT artist FROM artists WHERE id='$FORM{'id'}');
$query_output=$db->query($statement);
local($artist)=$query_output->fetchrow;
$statement=qq(SELECT DISTINCT(album) FROM songs WHERE artist='$FORM{'id'}' ORDER BY album ASC);
$query_output=$db->query($statement);
local($album);
&Top;
&Nav;
print qq(<TABLE ALIGN=center BORDER=0 CELLPADDING=2 CELLSPACING=2 CLASS="prgout" WIDTH=100%>
<TR><TD ALIGN=center COLSPAN=3><B>$artist</B></TD></TR>\n);
local($column)=1;
while(($album)=$query_output->fetchrow)
	{
	local($lalbum)=$album;$lalbum=~s/ /+/g;
	if($column==1)
		{
		print qq(<TR><TD CLASS="prgout" ALIGN=left WIDTH=33%><A HREF="$script?do=view+album&album=$lalbum&artist=$FORM{'id'}">$album</A></TD>\n);
		$column=2;
		}
	elsif($column==2)
		{
		print qq(<TD CLASS="prgout" ALIGN=left WIDTH=33%><A HREF="$script?do=view+album&album=$lalbum&artist=$FORM{'id'}">$album</A></TD>\n);
		$column=3;
		}
	else
		{
		print qq(<TD CLASS="prgout" ALIGN=left WIDTH=33%><A HREF="$script?do=view+album&album=$lalbum&artist=$FORM{'id'}">$album</A></TD></TR>\n);
		$column=1;
		}

	}
if($column==2){print qq(<TD CLASS="prgout" COLSPAN=2>&nbsp;</TD></TR>\n);}
if($column==3){print qq(<TD CLASS="prgout">&nbsp;</TD></TR>\n);}
print qq(</TABLE>\n);
&Bottom;
}

##

sub Top
{
print "content-type:  text/html\n\n";
open(FILE,"top.dat");
while(<FILE>)
	{
	print $_;
	}
close(FILE);
}

##

sub Bottom
{
open(FILE,"bottom.dat");
while(<FILE>)
	{
	print $_;
	}
close(FILE);
exit;
}

##

sub Get_Info
{
if ($ENV{'REQUEST_METHOD'} eq 'POST')
	{

	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs=split(/&/,$buffer);
	foreach $pair (@pairs)
		{
		($name,$value)=split(/=/,$pair);
		$name=~tr/+/ /;
		$name=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$name=~s/<!--(.|\n)*-->//g;
		$name=~s/<([^>]|\n)>//g;
		$value=~tr/+/ /;
		$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value=~s/<!--(.|\n)*-->//g;
		$value=~s/<([^>]|\n)>//g;
		$value=~s/\r//g;
		$FORM{$name}=$value;
		}
	}
else
	{
	$buffer=$ENV{'QUERY_STRING'};
	@pairs=split(/&/,$buffer);
	foreach $pair (@pairs)
		{
		($name,$value)=split(/=/,$pair);
		$name=~tr/+/ /;
		$name=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$name=~s/<!--(.|\n)*-->//g;
		$name=~s/<([^>]|\n)>//g;
		$value=~tr/+/ /;
		$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value=~s/<!--(.|\n)*-->//g;
		$value=~s/<([^>]|\n)>//g;
		$value=~s/\r//g;
		$FORM{$name}=$value;
		}
	}
}
